struct stat;
typedef void (*sighandler_t)(int);
typedef int pid_t;

// system calls
int fork(void);
int vfork(void);
int exit(int) __attribute__((noreturn));
int wait(int*);
int pipe(int*);
int write(int, const void*, int);
int read(int, void*, int);
int close(int);
int kill(int);
int exec(const char*, char**);
int open(const char*, int);
int mknod(const char*, short, short);
int unlink(const char*);
int fstat(int fd, struct stat*);
int link(const char*, const char*);
int mkdir(const char*);
int rmdir(const char*);
int chdir(const char*);
int dup(int);
int getpid(void);
char* sbrk(int);
int sleep(int);
int uptime(void);
int hello(void);
int ps(void);
int shutdown(void);
int top(void);
void rename(const char*,const char*);
int sched_yield(void);
int getppid(void);
int setpriority(int, int);
int trace(int);

// for signal handling
sighandler_t signal(int signum, sighandler_t handler);
int Kill(pid_t pid, int sig);
int raise(int sig);
uint sigsetmask(uint mask);
uint siggetmask(void);
void sigreturn(void);
uint sigblock(int);
uint sigunblock(int);

// ulib.c
int stat(const char*, struct stat*);
char* strcpy(char*, const char*);
void *memmove(void*, const void*, int);
char* strchr(const char*, char c);
int strcmp(const char*, const char*);
void fprintf(int, const char*, ...) __attribute__ ((format (printf, 2, 3)));
void printf(const char*, ...) __attribute__ ((format (printf, 1, 2)));
char* gets(char*, int max);
uint strlen(const char*);
void* memset(void*, int, uint);
int atoi(const char*);
int memcmp(const void *, const void *, uint);
void *memcpy(void *, const void *, uint);

// umalloc.c
void* malloc(uint);
void free(void*);
